<?php
/**
* Archivo de carga de datos iniciales al entrar
*
* @package agenda.php
* @copyright 2007 Ramón Castro Pérez, 2007 2008 Luis Jorge Martin Aznar
* @version 1.0
* @review 1
* @author Luis Jorge Martin Aznar
* creacion= 12-octubre-2007
* modificacion= 14-abril-2008
*
* generator= gedit
*
* This file is part of PreAdmin ©.
*
*    This program is free software: you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation, either version 3 of the License.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program.  If not, see <http://www.gnu.org/licenses/>.  
*/


session_start();

/**
*incluimos funciones,configuración e idioma
*/
include_once('../config.php');
include_once('../idioma/'.$idioma.'');
include_once('../modelo/m_agenda.php');
include_once('../modelo/m_mensajes.php');
/**
* si hay sesión cargamos código
*/
if (isset($_SESSION['usuario_sesion']))
{
	/**
	* aisgnamos variable de identificación de usuario
	*/
	$id_usuario = $_SESSION['id_usuario'];
	/**
	* si venimos de clicar en el calendario, estos son los nuevos datos de fecha
	*/
	$dia=$_POST['p1'];if(strlen($dia)=='1')$dia='0'.$dia.'';
	$mes=$_POST['p2'];if(strlen($mes)=='1')$mes='0'.$mes.'';
	$anyo=$_POST['p3'];
	
	$fecha_ing = ''.$anyo.'-'.$mes.'-'.$dia.'';
	$fecha_esp = ''.$dia.'-'.$mes.'-'.$anyo.'';
	
	$nombre_dia_ing = date('D', mktime(0, 0, 0, $mes, $dia, $anyo));
	$numero_dia = nombre_dia_a_numero($nombre_dia_ing);
	$nombre_dia=encuentra_dia($numero_dia-1,$id_calendario);
	

	/**
	* ¿mensajes nuevos?
	* @param $id_usuario integer del usuario
	*
	* @return la fecha del mensaje
	*/
	$sel_men_nu=mensajes_nuevos($id_usuario);

	/**
	* montamos agenda de trabajo;
	*/	

	/**
	* @return Obtenemos las franjas horarias en las que se divide la agenda
	*/	
	$franjas_agenda =franjas();	
	//Primero comprobamos si existen las franjas horarias en las que se divide la agenda
	$ns=0;
	if($franjas_agenda!='0')
		{
		/**
		* Para cada franja horaria en las que se divide la agenda creamos los arrays con los datos
		* para la capa vista
		* @param $agenda_añade array con las funciones para añadir citas en cada franja y hora
 		* @param $agenda_edita array con las funciones para editar las citas de cada franja y hora
 		* @param $agenda_borra array con las funciones para borrar las citas de cada franja y hora
 		* @param $agenda_citas array con las citas de cada franja y hora
		*
		*/	
		foreach ($franjas_agenda as  $reg_franja)
		{
				$hini_actual=$reg_franja['hini'];
				$orden=$reg_franja['franja'];
				$agenda_añade[$hini_actual][$orden]='new LITBox(\'citas.php?&id='.$ns.'&dia='.$dia.'&mes='.$mes.'&nhora='.$orden.'&numero_dia='.$numero_dia.'&anyo='.$anyo.'\', {type:\'window\', overlay:true, height:300, width:500, resizable:true});';
				$agenda_citas[$hini_actual][$orden]=citas_fraja($id_usuario,$orden,$numero_dia,$fecha_ing);
				$sel_citas=$agenda_citas[$hini_actual][$orden];
				if($sel_citas[0]!=0)
				{
					$i=0;
					foreach ($sel_citas as  $reg_citas)
					{
					$id_cita = $reg_citas['id'];
					$agenda_borra[$hini_actual][$orden][$i]='borraCita(\''.$id_cita.'\',\''.$dia.'\',\''.$mes.'\',\''.$anyo.'\')';
					$agenda_edita[$hini_actual][$orden][$i]='new LITBox(\'citas.php?idcita='.$id_cita.'&dia='.$dia.'&mes='.$mes.'&anyo='.$anyo.'&franja='.$franja.'&numero_dia='.$numero_dia.'\', {type:\'window\', overlay:true, height:300, width:500, resizable:true});';
					$i++;
					}
				}
	
		$ns++;
		}	
	include('../vista/agenda.vta');
	}//fin if 
	
}else{
	$formulario_swich='<font size=5><a href="javascript:history.go(-2)">'.$id_autenticacion['sesion'].'</a>';
	require('../vista/errorsesion.vta');

}//fin if sesión




/**
* Funcion que convierte el dia de la semana a su correspondiente número de dia
* @param $nombre_dia_ing string con el dia de la semana en formato corto e ingles
*
* @return el valor integer del dia de la semana
*/

function nombre_dia_a_numero($nombre_dia_ing)
{
switch($nombre_dia_ing)
	{
	case 'Mon':
	$numero='1';
	break;
	case 'Tue':
	$numero='2';
	break;
	case 'Wed':
	$numero='3';
	break;
	case 'Thu':
	$numero='4';
	break;
	case 'Fri':
	$numero='5';
	break;
	case 'Sat':
	$numero='6';
	break;
	case 'Sun':
	$numero='7';
	break;
	}
return $numero;
}



/**
* Funcion que convierte el numero de dia de la semana a su correspondiente nombre traducido
* @param $dia integer con el numero de dia de la semana 
* @param $id_calendario 
*
* @return el valor string del dia de la semana traducido
*/
function encuentra_dia($dia,$id_calendario){

switch ($dia)
	{
	case '0':
	$nombredia=$id_calendario['id_l'];
	break;
	case '1':
	$nombredia=$id_calendario['id_m'];
	break;
	case '2':
	$nombredia=$id_calendario['id_x'];
	break;
	case '3':
	$nombredia=$id_calendario['id_j'];
	break;
	case '4':
	$nombredia=$id_calendario['id_v'];
	break;
	case '5':
	$nombredia=$id_calendario['id_s'];
	break;
	case '6':
	$nombredia=$id_calendario['id_d'];
	break;
	}
return $nombredia;
}
?>


