<?php

/**
* Archivo de autenticacion control
*
* @package c_autenticacion.php
* @copyright 2007 2008 Luis Jorge Martin Aznar
* @version 1.0
* @review 1
* @author Luis Jorge Martin Aznar
* creacion= 12-octubre-2007
* modificacion= 20-noviembre-2007 
*
* generator= gedit
*
* This file is part of PreAdmin ©.
*
*    This program is free software: you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation, either version 3 of the License.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program.  If not, see <http://www.gnu.org/licenses/>.  
*/

/**
* Incluye el fichero modelo de autenticacion
*
*/
include_once('../modelo/m_autenticacion.php');


/**
* Funcion que autentica el usuario mediante comparación de usuario y contraseña
*
* Esta funcion autentica el usuario mediante comparación de usuario y contraseña. 
* Si la autenticación es positiva graba los datos de la conexión en la base de datos y
* comprueba que no haya caducado la contraseña. Si ha caducado redirige la acción al 
* cambio de contraseña. Si la autenticación es negativa graba el intento y resta una oportunidad
* para volver a logearse. Si el usuario no existe retorna 0.
*
* @param $_POST contiene la matriz asociativa de las variables del formulario 
* alojado en login.vta pasadas por el método POST.
* @param $id_autenticacion es el array con los valores (string) de las traducciones al idioma
* escogido.
*
* @return  0 si no se han introducido usuario y clave
* @return  1 si la autenticación no es correcta
* @return  2 si la autenticación es correcta
*/
function autentifica($_POST,$id_autenticacion)
{

$autenticado=array();
	$_SESSION['login']=$_POST['txt_login'];
	$_SESSION['password']=$_POST['pwd_clave'];
	//comprobamos que se han introducido usuario y clave
	if (isset($_POST['txt_login']) && isset($_POST['pwd_clave']))
	{
		$ip=getRealIP(); //obtenemos la ip
		$nombre_host = gethostbyaddr($ip); //obtenemos el host
		$usuario = $_POST['txt_login'];
		$clave = $_POST['pwd_clave'];
		$clave_crip = crypt($clave,'preadmin');
		$autenticado=autenti_usuario($usuario,$clave_crip);
		if($autenticado[0]!="" and $autenticado[0]!="NU")//nos aseguramos que hay coincidencia
	 	{
			$exitobd=grabaconexion($autenticado,$usuario,$ip,$nombre_host); //grabamos la conexión
	 		$nombre = $autenticado[0]['firstname'];
	 		$apellidos = $autenticado[0]['lastname'];
	 		$email = $autenticado[0]['email'];
			$date_password = $autenticado[0]['date_password'];
			$rol = $autenticado[0]['rol'];
			if($rol == '1') $perfil = 'admin';
			if($rol == '2') $perfil = 'Técnico';
 			if($rol == '3') $perfil = 'Responsable de evaluación';
	 		if($rol == '4') $perfil = 'Responsable de contrato'; 	
			if($rol == '5') $perfil = 'Responsable del servicio';
			if($rol == '6') $perfil = 'Gestor de instalación';
			if($rol == '7') $perfil = 'Delegado de prevención';
			if($rol == '8') $perfil = 'Trabajador municipal';
			if($rol == '9') $perfil = 'Gestor de contrata';
			if($rol == '10') $perfil = 'Trabajador de contrata';
	 		$_SESSION['usuario_sesion'] = $usuario;
	 		$_SESSION['rol_sesion'] = $perfil;
			$_SESSION['rol'] = $rol;
			$_SESSION['plan'] = $usuarios[0]['memoplan'];
			$_SESSION['nombre_sesion']=$nombre;
			$_SESSION['apellidos_sesion']=$apellidos;
			$_SESSION['especialidad_sesion']=$perfil;
			$_SESSION['contador']=0;
			$_SESSION['id_usuario']=$autenticado[0]['id_user'];
			$_SESSION['idioma']=$idioma;
			$_SESSION['clasebd']='../modelo/postgres.php';
			$doc_idusu = $autenticado[0]['id_user'];
			cuentadias($date_password);
			if (cuentadias($date_password) > 0)
			{
			return $exito_conexion[]=array(2);
			}else{
			return $exito_conexion[]=array(3);
			}
	 	}else{
			if ($autenticado[0]=="NU")//nos aseguramos que hay coincidencia
	 		{
			return $fracaso_conexion[]=array(0, $fracasobd);
			}else{
			$fracasobd=grabafracasoconexion($usuario,$ip,$nombre_host); //grabamos la conexión
			return $fracaso_conexion[]=array(1, $fracasobd);
			}
			
			unset($_SESSION);
			$estado_desconexion = session_destroy();
		}
	}else{
	return 0;
	}
}

function agendausuario()
{

if (isset($_SESSION['usuario_sesion'])) //nos aseguramos que la variable contenga valor
{
	$id_user=$_SESSION['id_usuario'];
	$sel_citas=citasenagenda($id_user); //colsultamos las citas de la agenda de hoy

	if($sel_citas[0]!="")//nos aseguramos que hay coincidencia
	{
	$agenda='cargaInicio('.date('d').','.date('m').','.date('Y').');new LITBox(\'cita_aviso.php\', {type:\'window\', overlay:true, height:700, width:300, resizable:true})';
	}
	else
	{
	$agenda='cargaInicio('.date('d').','.date('m').','.date('Y').')';
	}
return $agenda;
}
}

/**
* Funcion que obtiene la Ip de la conexión
*
* Esta funcion que obtiene la Ip de la conexión para grabarla en la tabla de conexiones. No tiene
* parámetros de entrada porque los obtiene de la variable global
*
* @return  0 si no se han introducido usuario y clave
* @return  1 si la autenticación no es correcta
* @return  2 si la autenticación es correcta
*/

///autor Patxi Echarte.//
function getRealIP()
{

if( $_SERVER['HTTP_X_FORWARDED_FOR'] !="" )
	{
	$client_ip =( !empty($_SERVER['REMOTE_ADDR']) ) ?$_SERVER['REMOTE_ADDR']:
	( ( !empty($_ENV['REMOTE_ADDR']) ) ?$_ENV['REMOTE_ADDR']:"unknown" );

/*
los proxys van añadiendo al final de esta cabecera
las direcciones ip que van "ocultando". Para localizar la ip real
del usuario se comienza a mirar por el principio hasta encontrar
una dirección ip que no sea del rango privado. En caso de no
encontrarse ninguna se toma como valor el REMOTE_ADDR
*/
	$entries = split('[, ]', $_SERVER['HTTP_X_FORWARDED_FOR']);

	reset($entries);
	while (list(, $entry) = each($entries))
	{
	$entry = trim($entry);
	if ( preg_match("/^([0-9]+.[0-9]+.[0-9]+.[0-9]+)/", $entry, $ip_list) )
		{
		$private_ip = array(
		'/^0./',
		'/^127.0.0.1/',
		'/^192.168..*/',
		'/^172.((1[6-9])|(2[0-9])|(3[0-1]))..*/',
		'/^10..*/');
	
		$found_ip = preg_replace($private_ip, $client_ip, $ip_list[1]);
	
		if ($client_ip != $found_ip)
			{
			$client_ip = $found_ip;
			break;
			}
		}
	}
}else{
	$client_ip =
	( !empty($_SERVER['REMOTE_ADDR']) ) ?
	$_SERVER['REMOTE_ADDR']:( ( !empty($_ENV['REMOTE_ADDR']) ) ?$_ENV['REMOTE_ADDR']:"unknown" );
}
return $client_ip;
}

function cambiopw($_POST){
$clave=$_POST['pwd_1'];
$cla_cryp = crypt($clave,'preadmin');
$exitobd=grabacambiopw($cla_cryp);
return '1';
}


function cuentadias($fecha1){
$tiempo_cambio=6*30*86400;
$fecha_last = strtotime($fecha1, 0);
$fecha_last=$fecha_last+$tiempo_cambio;
$hoy = date("Y-m-d");
$hoy = strtotime($hoy, 0);
$cuanto = $fecha_last-$hoy;
$dif = round($cuanto / 86400);
return $dif;
}



?>
