<?php
/**
* Archivo de funciones de calendario
*
* @package funciones_calendario.php
* @copyright 2007 2008 Luis Jorge Martin Aznar
* @version 1.0
* @review 1
* @author Luis Jorge Martin Aznar
* creacion= 12-octubre-2007
* modificacion= 14-abril-2008
*
* generator= gedit
*
* This file is part of PreAdmin ©.
*
*    This program is free software: you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation, either version 3 of the License.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program.  If not, see <http://www.gnu.org/licenses/>.  
*/

/**
* Funcion que sustituye el número de mes por su traducción al idioma escogido
*
* Esta funcion sustituye el número de mes que se le pasa como argumento por su
* correspondiente traducción al idioma escogido.
*
* @param $mes contiene el valor, tipo integer, del mes a convertir
* @param $id_calendario es el array con los valores (string) de las traducciones
*
* @return El valor almacenado en el array asociativo con el indice correspondiente al mes. 
*/

function numero_mes_a_nombre($mes,$id_calendario)
{

if($mes == 1) return $id_calendario['id_ene'];
if($mes == 2) return $id_calendario['id_feb'];
if($mes == 3) return $id_calendario['id_mar'];
if($mes == 4) return $id_calendario['id_abr'];
if($mes == 5) return $id_calendario['id_may'];
if($mes == 6) return $id_calendario['id_jun'];
if($mes == 7) return $id_calendario['id_jul'];
if($mes == 8) return $id_calendario['id_ago'];
if($mes == 9) return $id_calendario['id_sep'];
if($mes == 10) return $id_calendario['id_oct'];
if($mes == 11) return $id_calendario['id_nov'];
if($mes == 12) return $id_calendario['id_dic'];
}

/**
* Funcion que sustituye el dia de la semana por su traducción al idioma escogido
*
* Esta funcion sustituye el dia de la semana que se le pasa como argumento por su
* correspondiente traducción al idioma escogido.
*
* @param $day contiene el valor, tipo string, del dia de la semana a convertir
* @param $id_calendario es el array con los valores (string) de las traducciones
*
* @return El valor almacenado en el array asociativo $id_calendario con el indice correspondiente al dia de la semana. 
*/

function dia_esp($day,$id_calendario)
{
if ($day=='Monday') return $id_calendario['id_l'];
if ($day=='Tuesday') return $id_calendario['id_m'];
if ($day=='Wednesday') return $id_calendario['id_x'];
if ($day=='Thursday') return $id_calendario['id_j'];
if ($day=='Friday') return $id_calendario['id_v'];
if ($day=='Saturday') return $id_calendario['id_s'];
if ($day=='Sunday') return $id_calendario['id_d'];
}

/**
* Funcion que devuelve el último día de un mes y año dados
*
* Esta funcion devuelve el último día de un mes y año pasados como argumento. 
*
* @param $mes contiene el valor, tipo integer, del mes correspondiente
* @param $anyo contiene el valor, tipo integer, del año correspondiente
*
* @return El valor acumulado en la variable $ultimo_dia. 
*/
function ultimo_dia($mes,$anyo){ 
    $ultimo_dia=28; 
	//La función checkdate() se utiliza para validar una fecha, es decir si el dia del mes es valido para el mes indicado en la fecha.
	// Los años válidos son entre 0 y 32767 ambos incluidos.
    while (checkdate($mes,$ultimo_dia + 1,$anyo)){ 
       $ultimo_dia++; 
    } 
    return $ultimo_dia; 
} 
?>
