<?php
/**
* Archivo modelo de agenda
*
* @package m_agenda.php
* @copyright 2007 2008 Luis Jorge Martin Aznar
* @version 1.0
* @author Luis Jorge Martin Aznar
* creacion= 12-octubre-2007
* modificacion= 20-noviembre-2007 
*
* generator= gedit
*
* This file is part of PreAdmin ©.
*
*    This program is free software: you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation, either version 3 of the License.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program.  If not, see <http://www.gnu.org/licenses/>.  
*/
/**
* Incluye el fichero de clases para postgres
*
*/
include_once('../modelo/postgres.php');


/**
* Funcion para obtener los tramos horarios de la agenda
*
* Con esta función se obtienen los tramos horarios de la agenda en los que se pueden anotar citas.
* Se puede personalizar en la instalación.
* @param . No tiene parámetros de entrada
* @return Un array con los valores de la base de datos hora inicial y orden
*/
function franjas()
{
$conecto=new bd();
$conexion=$conecto->conectar();
	if ($conexion=="conectado")
	{
	$conecto->begin ();
	$conexion=$conecto->query_c ("select franjas.hini,franjas.franja from franjas order by franjas.id_franja");
	if($conexion[0]!="")//nos aseguramos que hay coincidencia
	{
		$result = $conexion;
	}else{
		$result = '0';
	}
	$conecto->commit();
	return $result;
	}
unset ($conecto);
}

/**
* Funcion para obtener las citas para cada tramo horario de la agenda
*
* Con esta función se obtienen las citas que exiten en cada tramo horario de la agenda
* Se puede personalizar en la instalación.
* @param $usuario es de tipo integer y se corresponde con el usuario de la agenda
* @param $franja es de tipo integer y se corresponde con la franja horaria en la que se realiza la consulta
* @param $numero_dia es de tipo integer y se corresponde con el número de dia de la semana
* @param $fecha_ing es de tipo fecha y se corresponde con la fecha de la consulta con el formato anglosajón
* @return Un array con los valores de la tabla agenda filtrados por los parámetros
*/
function citas_fraja($usuario,$franja,$numero_dia,$fecha_ing)
{
$conecto=new bd();
$conexion=$conecto->conectar();
	if ($conexion=="conectado")
	{
	$conecto->begin ();
	$conexion=$conecto->query_c ("select * from agenda where id_user = '$usuario' and franja = '$franja' and dia = '$numero_dia' and fecha='$fecha_ing'");
	if($conexion[0]!="")//nos aseguramos que hay coincidencia
	{
		$result = $conexion;
	}else{
		$result = '0';
	}
	$conecto->commit();
	return $result;
	}
unset ($conecto,$result);
}


/**
* Funcion para obtener el contenido de una cita
*
* Con esta función se obtienen todos los campos de una cita concreta
* @param $idcita es de tipo integer y se corresponde con primary key de la tabla citas

* @return Un array con los valores del registro 
*/
function citas_editar($idcita)
{
$idcita=$idcita;
$conecto=new bd();
$conexion=$conecto->conectar();
	if ($conexion=="conectado")
	{
	$conecto->begin ();
	$conexion=$conecto->query_c ("select * from agenda where id='$idcita'");
	if($conexion[0]!="")//nos aseguramos que hay coincidencia
	{
		$result = $conexion;
	}else{
		$result = '0';
	}
	$conecto->commit();
	return $result;
	}
unset ($conecto,$result);
}

/**
* Funcion para actualizar el contenido de una cita
*
* Con esta función se actualiza el contenido de una cita concreta
* @param $id es de tipo integer y se corresponde con primary key de la tabla citas
* @param $mensaje es de tipo string y se corresponde con el texto del nuevo mensaje
* @return cero en caso de error
*/
function actualizacita($mensaje,$id)
{
$conecto=new bd();
$conexion=$conecto->conectar();
	if ($conexion=="conectado")
	{
	$conecto->begin ();
	$conexion=$conecto->query ("update agenda set cita='$mensaje' where id='$id'");
	if($conexion[0]!="")//nos aseguramos que hay coincidencia
	{
		$result = $conexion;
	}else{
		$result = '0';
	}
	$conecto->commit();
	return $result;
	}
unset ($conecto,$result);
}


/**
* Funcion para anadir una cita nueva
*
* Con esta función se agrega una nueva cita a la agenda
* @param $usuario es de tipo integer y se corresponde con primary key de la tabla citas
* @param $mensaje es de tipo string y se corresponde con el texto del nuevo mensaje
* @param $franjacita es de tipo integer y se corresponde con la franja horaria en la que se realiza la consulta
* @param $diacita es de tipo integer y se corresponde con el número de dia de la semana
* @param $fecha_ing es de tipo fecha y se corresponde con la fecha de la consulta con el formato anglosajón
*
* @return cero en caso de error
*/
function grabacita($usuario,$fecha_ing,$mensaje,$franjacita,$diacita)
{
$tipocita=1;
$conecto=new bd();
$conexion=$conecto->conectar();
	if ($conexion=="conectado")
	{
	$conecto->begin ();
	$conexion=$conecto->query ("insert into agenda(id_user,fecha,cita,tipo,franja,dia) values('$usuario','$fecha_ing','$mensaje','$tipocita',$franjacita,'$diacita')");
	if($conexion[0]!="")//nos aseguramos que hay coincidencia
	{
		$result = $conexion;
	}else{
		$result = '0';
	}
	$conecto->commit();
	return $result;
	}
unset ($conecto,$result);
}

/**
* Funcion para borrar una cita
*
* Con esta función se borra una cita concreta
* @param $id es de tipo integer y se corresponde con primary key de la tabla citas
*
* @return cero en caso de error
*/
function borracita($id)
{
$conecto=new bd();
$conexion=$conecto->conectar();
	if ($conexion=="conectado")
	{
	$conecto->begin ();
	$conexion=$conecto->query ("delete from agenda where id='$id'");
	if($conexion[0]!="")//nos aseguramos que hay coincidencia
	{
		$result = '1';
	}else{
		$result = '0';
	}
	$conecto->commit();
	return $result;
	}
unset ($conecto,$result);
}



?>
